/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ReportConfigurationMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ReportConfigurationMutable{}

// ReportConfigurationMutable struct for ReportConfigurationMutable
type ReportConfigurationMutable struct {
	Name string `json:"name"`
	Scope *ReportConfigurationScope `json:"scope,omitempty"`
	Data *ReportConfigurationData `json:"data,omitempty"`
	// Applies to global & organization scopes
	Active *bool `json:"active,omitempty"`
}

// NewReportConfigurationMutable instantiates a new ReportConfigurationMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportConfigurationMutable(name string) *ReportConfigurationMutable {
	this := ReportConfigurationMutable{}
	this.Name = name
	return &this
}

// NewReportConfigurationMutableWithDefaults instantiates a new ReportConfigurationMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportConfigurationMutableWithDefaults() *ReportConfigurationMutable {
	this := ReportConfigurationMutable{}
	return &this
}

// GetName returns the Name field value
func (o *ReportConfigurationMutable) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ReportConfigurationMutable) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ReportConfigurationMutable) SetName(v string) {
	o.Name = v
}

// GetScope returns the Scope field value if set, zero value otherwise.
func (o *ReportConfigurationMutable) GetScope() ReportConfigurationScope {
	if o == nil || IsNil(o.Scope) {
		var ret ReportConfigurationScope
		return ret
	}
	return *o.Scope
}

// GetScopeOk returns a tuple with the Scope field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationMutable) GetScopeOk() (*ReportConfigurationScope, bool) {
	if o == nil || IsNil(o.Scope) {
		return nil, false
	}
	return o.Scope, true
}

// HasScope returns a boolean if a field has been set.
func (o *ReportConfigurationMutable) HasScope() bool {
	if o != nil && !IsNil(o.Scope) {
		return true
	}

	return false
}

// SetScope gets a reference to the given ReportConfigurationScope and assigns it to the Scope field.
func (o *ReportConfigurationMutable) SetScope(v ReportConfigurationScope) {
	o.Scope = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *ReportConfigurationMutable) GetData() ReportConfigurationData {
	if o == nil || IsNil(o.Data) {
		var ret ReportConfigurationData
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationMutable) GetDataOk() (*ReportConfigurationData, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *ReportConfigurationMutable) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given ReportConfigurationData and assigns it to the Data field.
func (o *ReportConfigurationMutable) SetData(v ReportConfigurationData) {
	o.Data = &v
}

// GetActive returns the Active field value if set, zero value otherwise.
func (o *ReportConfigurationMutable) GetActive() bool {
	if o == nil || IsNil(o.Active) {
		var ret bool
		return ret
	}
	return *o.Active
}

// GetActiveOk returns a tuple with the Active field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationMutable) GetActiveOk() (*bool, bool) {
	if o == nil || IsNil(o.Active) {
		return nil, false
	}
	return o.Active, true
}

// HasActive returns a boolean if a field has been set.
func (o *ReportConfigurationMutable) HasActive() bool {
	if o != nil && !IsNil(o.Active) {
		return true
	}

	return false
}

// SetActive gets a reference to the given bool and assigns it to the Active field.
func (o *ReportConfigurationMutable) SetActive(v bool) {
	o.Active = &v
}

func (o ReportConfigurationMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ReportConfigurationMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	if !IsNil(o.Scope) {
		toSerialize["scope"] = o.Scope
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	if !IsNil(o.Active) {
		toSerialize["active"] = o.Active
	}
	return toSerialize, nil
}

type NullableReportConfigurationMutable struct {
	value *ReportConfigurationMutable
	isSet bool
}

func (v NullableReportConfigurationMutable) Get() *ReportConfigurationMutable {
	return v.value
}

func (v *NullableReportConfigurationMutable) Set(val *ReportConfigurationMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableReportConfigurationMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableReportConfigurationMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportConfigurationMutable(val *ReportConfigurationMutable) *NullableReportConfigurationMutable {
	return &NullableReportConfigurationMutable{value: val, isSet: true}
}

func (v NullableReportConfigurationMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportConfigurationMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


